#ifndef COMMON_CK
#define COMMOM_CK

#include "myEigen.h"

namespace cmmn {

	using namespace System;

	using namespace myLib;

	extern double ** x_raw;  

	extern myMat x;

	extern int n, p, q;

	extern double * mean, * sd;

	double sqr( double v );


	class VariMax {
		public:
			int p,
				q;
			double ** F, ** Ftemp;
			double * Contri, * h;

			VariMax(){}
			VariMax( myMat & vF, int vp, int vq, double * vh, double * vContri ){
				p = vp;
				q = vq;
				F = new double*[p];
				for (int i = 0; i < p; i++){
					F[i] = new double[q];
					for (int j = 0; j < q; j++)
						F[i][j] = vF[i][j];
				}
				Ftemp = new double*[p];
				for (int i = 0; i < p; i++){
					Ftemp[i] = new double[q];
				}
				h = vh;
				Contri = vContri;
			}

			virtual ~VariMax(){
				if (F != nullptr){
					for (int i = 0; i < p; i++)
						delete [] F[i];
					delete [] F;
				}
				if (Ftemp != nullptr){
					for (int i = 0; i < p; i++)
						delete [] Ftemp[i];
					delete [] Ftemp;
				}
			}

			void Init( myMat & vF, int vp, int vq, double * vh, double * vContri ){
				p = vp;
				q = vq;
				F = new double*[p];
				for (int i = 0; i < p; i++){
					F[i] = new double[q];
					for (int j = 0; j < q; j++)
						F[i][j] = vF[i][j];
				}
				Ftemp = new double*[p];
				for (int i = 0; i < p; i++){
					Ftemp[i] = new double[q];
				}
				h = vh;
				Contri = vContri;
			}

			void RotateByPair( int i, int j );

			void Rotate();

			bool LhLargerRh( int a, int b );

			void OrderF( array<String ^> ^ VLabel );

	};


	class ProMax {
		public:
			int p, q;
			double ** A, ** B, ** C, ** Lambda, ** Phi, ** S;
			double r;

			ProMax(){ };
			ProMax( double ** vF, int vp, int vq, double vr ){
				A = vF;
				p = vp;
				q = vq;
				r = vr;
				B = new double*[p];
				for (int i = 0; i < p; i++)
					B[i] = new double[q];
				C = new double*[p];
				for (int i = 0; i < p; i++)
					C[i] = new double[q];
				Phi = new double*[q];
				for (int i = 0; i < q; i++)
					Phi[i] = new double[q];
				Lambda = new double*[q];
				for (int i = 0; i < q; i++)
					Lambda[i] = new double[q];
			}

			~ProMax(){
				if (B != nullptr){
					for (int i = 0; i < p; i++)
						delete [] B[i];
					delete [] B;
				}
				if (C != nullptr){
					for (int i = 0; i < p; i++)
						delete [] C[i];
					delete [] C;
				}
				if (Phi != nullptr){
					for (int i = 0; i < q; i++)
						delete [] Phi[i];
					delete [] Phi;
				}
				if (Lambda != nullptr){
					for (int i = 0; i < q; i++)
						delete [] Lambda[i];
					delete [] Lambda;
				}
			}

			void Init( double ** vF, int vp, int vq, double vr ){
				A = vF;
				p = vp;
				q = vq;
				r = vr;
				B = new double*[p];
				for (int i = 0; i < p; i++)
					B[i] = new double[q];
				C = new double*[p];
				for (int i = 0; i < p; i++)
					C[i] = new double[q];
				Phi = new double*[q];
				for (int i = 0; i < q; i++)
					Phi[i] = new double[q];
				Lambda = new double*[q];
				for (int i = 0; i < q; i++)
					Lambda[i] = new double[q];
			}

			void ObliqueProcrustes();

			double PowerR( double a, double r );

			void Rotate();

			bool LhLargerRh( int a, int b );

			void OrderB( array<String^> ^ VLabel );

	};


}

#endif
